/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NULLV = 258,
     INTEGER = 259,
     REAL = 260,
     STRING = 261,
     SYMBOL = 262,
     LITERAL = 263,
     WHILE = 264,
     IF = 265,
     SUB = 266,
     FOREACH = 267,
     LOCAL = 268,
     BREAK = 269,
     RETURN = 270,
     IFI = 271,
     ELSE = 272,
     BOOLOR = 273,
     BOOLAND = 274,
     ISHL = 275,
     ISHR = 276,
     IBITXOR = 277,
     IBITOR = 278,
     IBITAND = 279,
     IMOD = 280,
     IDIV = 281,
     IMUL = 282,
     ISUB = 283,
     IADD = 284,
     DEC = 285,
     INC = 286,
     INVCALL = 287,
     RANGE = 288,
     HASHPAIR = 289,
     NUMLE = 290,
     NUMGE = 291,
     NUMNE = 292,
     STRNE = 293,
     NUMEQ = 294,
     STREQ = 295,
     STRCAT = 296,
     BITAND = 297,
     BITXOR = 298,
     BITOR = 299,
     SHR = 300,
     SHL = 301,
     POW = 302,
     MOD = 303,
     UMINUS = 304
   };
#endif
/* Tokens.  */
#define NULLV 258
#define INTEGER 259
#define REAL 260
#define STRING 261
#define SYMBOL 262
#define LITERAL 263
#define WHILE 264
#define IF 265
#define SUB 266
#define FOREACH 267
#define LOCAL 268
#define BREAK 269
#define RETURN 270
#define IFI 271
#define ELSE 272
#define BOOLOR 273
#define BOOLAND 274
#define ISHL 275
#define ISHR 276
#define IBITXOR 277
#define IBITOR 278
#define IBITAND 279
#define IMOD 280
#define IDIV 281
#define IMUL 282
#define ISUB 283
#define IADD 284
#define DEC 285
#define INC 286
#define INVCALL 287
#define RANGE 288
#define HASHPAIR 289
#define NUMLE 290
#define NUMGE 291
#define NUMNE 292
#define STRNE 293
#define NUMEQ 294
#define STREQ 295
#define STRCAT 296
#define BITAND 297
#define BITXOR 298
#define BITOR 299
#define SHR 300
#define SHL 301
#define POW 302
#define MOD 303
#define UMINUS 304




/* Copy the first part of user declarations.  */
#line 1 "mpsl.y"

/*

    MPSL - Minimum Profit Scripting Language
    Copyright (C) 2003/2010 Angel Ortega <angel@triptico.com>

    mpsl.y - Minimum Profit Scripting Language YACC parser

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    http://www.triptico.com

*/

#include <stdio.h>
#include <string.h>
#include <wchar.h>
#include "mpdm.h"
#include "mpsl.h"

/*******************
	Data
********************/

/* the bytecode being generated */
static mpdm_t mpsl_bytecode = NULL;

/* pointer to source code being compiled */
extern wchar_t * mpsl_next_char;

/* pointer to file being compiled */
extern FILE * mpsl_file;

/* line number */
extern int mpsl_line;

/* compiled filename (for errors) */
static char * mpsl_filename = NULL;

/* cached value MPSL.OPCODE */
extern mpdm_t mpsl_opcodes;

/* cached value MPSL.LC */
extern mpdm_t mpsl_lc;

/*******************
	Code
********************/

int yylex(void);
void yyerror(char * s);

#define INS0(o)			mpsl_mkins(o, 0, NULL, NULL, NULL)
#define INS1(o,a1)		mpsl_mkins(o, 1, a1, NULL, NULL)
#define INS2(o,a1,a2)		mpsl_mkins(o, 2, a1, a2, NULL)
#define INS3(o,a1,a2,a3)	mpsl_mkins(o, 3, a1, a2, a3)

static mpdm_t mpsl_x(mpdm_t a1, mpdm_t a2, int sf)
/* creates an executable value with the MPSL executor as the first
   argument and a compiled stream as the second */
{
	return MPDM_X2(mpsl_exec_p,
		mpsl_mkins(sf ? L"SUBFRAME" : L"BLKFRAME",
			a2 == NULL ? 1 : 2, a1, a2, NULL));
}


static void compiler_warning(char * str)
{
	fprintf(stderr, "WARNING: %s.\n", str);
}




/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 88 "mpsl.y"
{
	mpdm_t v;	/* a simple value */
	mpdm_t ins;	/* an 'instruction': [ opcode, args ] */
}
/* Line 187 of yacc.c.  */
#line 286 "y.tab.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 299 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1249

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  67
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  88
/* YYNRULES -- Number of states.  */
#define YYNSTATES  203

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   304

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,     2,     2,     2,
      58,    59,    52,    50,    62,    51,    64,    53,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    57,
      34,    63,    33,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    65,     2,    66,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    60,     2,    61,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    54,    55,    56
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    11,    14,    20,    26,
      34,    40,    48,    57,    65,    74,    78,    82,    88,    91,
      95,    98,   100,   103,   105,   109,   111,   115,   119,   125,
     127,   131,   135,   140,   142,   144,   146,   148,   150,   153,
     157,   161,   165,   169,   173,   177,   181,   185,   189,   193,
     197,   200,   203,   206,   209,   213,   217,   221,   225,   229,
     233,   237,   241,   245,   249,   252,   256,   260,   264,   268,
     272,   276,   280,   284,   288,   292,   296,   301,   309,   313,
     316,   320,   326,   329,   333,   337,   342,   348,   355
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      68,     0,    -1,    69,    -1,    69,    71,    -1,    -1,    57,
      -1,    76,    57,    -1,     9,    58,    76,    59,    70,    -1,
      10,    58,    76,    59,    70,    -1,    10,    58,    76,    59,
      70,    17,    70,    -1,    11,    75,    60,    71,    61,    -1,
      11,    75,    58,    59,    60,    71,    61,    -1,    11,    75,
      58,    73,    59,    60,    71,    61,    -1,    12,    58,    75,
      62,    76,    59,    70,    -1,    12,    58,    13,    75,    62,
      76,    59,    70,    -1,    60,    71,    61,    -1,    13,    73,
      57,    -1,    13,     7,    63,    76,    57,    -1,    14,    57,
      -1,    15,    76,    57,    -1,    15,    57,    -1,    70,    -1,
      71,    70,    -1,    76,    -1,    72,    62,    76,    -1,     7,
      -1,    73,    62,     7,    -1,    76,    37,    76,    -1,    74,
      62,    76,    37,    76,    -1,     7,    -1,    75,    64,     4,
      -1,    75,    64,     7,    -1,    75,    65,    76,    66,    -1,
       4,    -1,     6,    -1,     5,    -1,    75,    -1,     3,    -1,
      51,    76,    -1,    76,    50,    76,    -1,    76,    51,    76,
      -1,    76,    52,    76,    -1,    76,    53,    76,    -1,    76,
      55,    76,    -1,    76,    54,    76,    -1,    76,    45,    76,
      -1,    76,    47,    76,    -1,    76,    46,    76,    -1,    76,
      49,    76,    -1,    76,    48,    76,    -1,    31,    75,    -1,
      30,    75,    -1,    75,    31,    -1,    75,    30,    -1,    75,
      29,    76,    -1,    75,    28,    76,    -1,    75,    27,    76,
      -1,    75,    26,    76,    -1,    75,    25,    76,    -1,    75,
      24,    76,    -1,    75,    23,    76,    -1,    75,    22,    76,
      -1,    75,    20,    76,    -1,    75,    21,    76,    -1,    32,
      76,    -1,    76,    34,    76,    -1,    76,    33,    76,    -1,
      76,    38,    76,    -1,    76,    39,    76,    -1,    76,    42,
      76,    -1,    76,    40,    76,    -1,    76,    44,    76,    -1,
      76,    43,    76,    -1,    76,    41,    76,    -1,    76,    19,
      76,    -1,    76,    18,    76,    -1,    11,    60,    71,    61,
      -1,    11,    58,    73,    59,    60,    71,    61,    -1,    58,
      76,    59,    -1,    65,    66,    -1,    65,    72,    66,    -1,
      65,    76,    36,    76,    66,    -1,    60,    61,    -1,    60,
      74,    61,    -1,    75,    58,    59,    -1,    75,    58,    72,
      59,    -1,    76,    35,    75,    58,    59,    -1,    76,    35,
      75,    58,    72,    59,    -1,    75,    63,    76,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   114,   114,   118,   121,   125,   129,   134,   139,   144,
     150,   159,   169,   178,   190,   202,   208,   212,   223,   227,
     231,   238,   239,   246,   249,   257,   261,   269,   272,   281,
     285,   290,   295,   302,   306,   310,   314,   318,   323,   329,
     330,   331,   332,   333,   334,   337,   338,   339,   340,   341,
     344,   351,   360,   370,   382,   388,   394,   400,   406,   412,
     418,   424,   430,   436,   443,   447,   451,   455,   459,   463,
     467,   473,   477,   481,   487,   491,   496,   501,   507,   512,
     516,   520,   526,   530,   535,   539,   543,   547,   551
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NULLV", "INTEGER", "REAL", "STRING",
  "SYMBOL", "LITERAL", "WHILE", "IF", "SUB", "FOREACH", "LOCAL", "BREAK",
  "RETURN", "IFI", "ELSE", "BOOLOR", "BOOLAND", "ISHL", "ISHR", "IBITXOR",
  "IBITOR", "IBITAND", "IMOD", "IDIV", "IMUL", "ISUB", "IADD", "DEC",
  "INC", "'!'", "'>'", "'<'", "INVCALL", "RANGE", "HASHPAIR", "NUMLE",
  "NUMGE", "NUMNE", "STRNE", "NUMEQ", "STREQ", "STRCAT", "BITAND",
  "BITXOR", "BITOR", "SHR", "SHL", "'+'", "'-'", "'*'", "'/'", "POW",
  "MOD", "UMINUS", "';'", "'('", "')'", "'{'", "'}'", "','", "'='", "'.'",
  "'['", "']'", "$accept", "program", "function", "stmt", "stmt_list",
  "list", "sym_list", "hash", "compsym", "expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    33,    62,    60,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
      43,    45,    42,    47,   302,   303,   304,    59,    40,    41,
     123,   125,    44,    61,    46,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    67,    68,    69,    69,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
      70,    71,    71,    72,    72,    73,    73,    74,    74,    75,
      75,    75,    75,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     1,     2,     5,     5,     7,
       5,     7,     8,     7,     8,     3,     3,     5,     2,     3,
       2,     1,     2,     1,     3,     1,     3,     3,     5,     1,
       3,     3,     4,     1,     1,     1,     1,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     7,     3,     2,
       3,     5,     2,     3,     3,     4,     5,     6,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     2,     1,    37,    33,    35,    34,    29,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     0,     0,     0,    21,     3,    36,     0,     0,     0,
       0,     0,     0,     0,    25,     0,    18,     0,    20,     0,
       0,    51,    50,    64,    38,     0,    82,     0,     0,     0,
      79,     0,    23,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,    52,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     0,     0,    25,     0,     0,     0,
       0,     0,     0,     0,    16,     0,     0,    19,    78,    15,
      83,     0,     0,     0,    80,     0,    62,    63,    61,    60,
      59,    58,    57,    56,    55,    54,    84,     0,    23,    88,
      30,    31,     0,    75,    74,    66,    65,     0,    67,    68,
      70,    73,    69,    72,    71,    45,    47,    46,    49,    48,
      39,    40,    41,    42,    44,    43,     0,     0,     0,    76,
       0,     0,     0,     0,     0,     0,    26,     0,    27,    24,
       0,    85,    32,     0,     7,     8,     0,     0,     0,    10,
       0,     0,    17,     0,    81,    86,     0,     0,     0,     0,
       0,     0,     0,    28,    87,     9,    77,    11,     0,     0,
      13,    12,    14
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,    24,    25,    51,    35,    48,    26,    27
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -65
static const yytype_int16 yypact[] =
{
     -65,    29,   445,   -65,   -65,   -65,   -65,   -65,   -65,     0,
      21,    -4,    66,    39,    73,   508,   133,   133,   603,   603,
     -65,   603,   204,   140,   -65,   445,   -16,   937,   603,   603,
     142,   445,    63,    30,   105,   -12,   -65,    90,   -65,   518,
     977,   101,   101,  1194,   -65,   707,   -65,   217,    -9,   897,
     -65,   -11,  1057,   -65,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   -65,   -65,   530,   603,   115,   603,
     603,   603,   603,   603,   133,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   -65,   745,   783,   -65,    67,   280,    10,
     445,   133,   -46,   603,   -65,   172,  1095,   -65,   -65,   -65,
     -65,   603,   603,   603,   -65,   603,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,   -65,    79,  1171,  1171,
     -65,   -65,   631,  1194,  1194,   570,   570,   -33,   570,   570,
     570,   570,   570,   570,   570,   106,    52,    52,    60,    60,
      81,    81,   -65,   -65,   -65,   -65,   445,   445,   121,   -65,
     122,    80,   293,   -26,   603,  1017,   -65,  1133,  1171,  1171,
     669,   -65,   -65,   540,   -65,   166,   445,   445,   124,   -65,
     603,   821,   -65,   603,   -65,   -65,   118,   445,   356,   369,
     445,   859,   445,  1171,   -65,   -65,   -65,   -65,   432,   445,
     -65,   -65,   -65
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -65,   -65,   -65,   -25,    -1,   -64,   -29,   -65,    24,     5
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      53,    97,   127,     8,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,   164,    96,    68,    69,
      40,    47,    53,    43,    44,   173,    45,    49,    52,     3,
      98,    68,    69,    94,    95,    32,   180,     8,    68,    69,
      41,    42,    66,   101,   106,   104,    34,    67,    68,    69,
     105,   113,   110,   111,    30,   114,    31,   102,    28,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   160,
     161,   128,   129,    53,   132,   133,   134,   135,   136,    29,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   137,   162,
      85,    86,    87,    88,    89,    90,    91,    92,   165,   186,
      87,    88,    89,    90,    91,    92,   167,   168,   169,   130,
     170,    99,   131,   100,    33,   163,   158,    68,    69,   105,
      36,   174,   175,    89,    90,    91,    92,    53,   171,   178,
       8,   113,   105,     4,     5,     6,     7,     8,    30,    96,
      31,    37,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,   195,    53,    53,    68,    69,   200,   103,   181,
      16,    17,    18,    53,   202,   188,   189,   194,   128,   166,
     113,   176,   177,   187,   190,   191,     0,     0,   193,   198,
       0,    19,     0,     0,     0,     0,     0,     0,    21,     0,
      39,     0,     0,     0,     0,    23,    50,     4,     5,     6,
       7,     8,     0,     9,    10,    11,    12,    13,    14,    15,
       4,     5,     6,     7,     8,     0,     9,    10,    11,    12,
      13,    14,    15,     0,    16,    17,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,    18,
       0,     0,     0,     0,     0,    19,     0,     0,     0,     0,
       0,    20,    21,     0,    22,    46,     0,     0,    19,    23,
       0,     0,     0,     0,    20,    21,     0,    22,   109,     0,
       0,     0,    23,     4,     5,     6,     7,     8,     0,     9,
      10,    11,    12,    13,    14,    15,     4,     5,     6,     7,
       8,     0,     9,    10,    11,    12,    13,    14,    15,     0,
      16,    17,    18,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,    18,     0,     0,     0,     0,
       0,    19,     0,     0,     0,     0,     0,    20,    21,     0,
      22,   159,     0,     0,    19,    23,     0,     0,     0,     0,
      20,    21,     0,    22,   179,     0,     0,     0,    23,     4,
       5,     6,     7,     8,     0,     9,    10,    11,    12,    13,
      14,    15,     4,     5,     6,     7,     8,     0,     9,    10,
      11,    12,    13,    14,    15,     0,    16,    17,    18,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,    18,     0,     0,     0,     0,     0,    19,     0,     0,
       0,     0,     0,    20,    21,     0,    22,   196,     0,     0,
      19,    23,     0,     0,     0,     0,    20,    21,     0,    22,
     197,     0,     0,     0,    23,     4,     5,     6,     7,     8,
       0,     9,    10,    11,    12,    13,    14,    15,     4,     5,
       6,     7,     8,     0,     9,    10,    11,    12,    13,    14,
      15,     0,    16,    17,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,    18,     0,     0,
       0,     0,     0,    19,     0,     0,     0,     0,     0,    20,
      21,     0,    22,   201,     0,     0,    19,    23,     0,     0,
       0,     0,    20,    21,     0,    22,     0,     0,     0,     0,
      23,     4,     5,     6,     7,     8,     0,     0,     0,    37,
       0,     4,     5,     6,     7,     8,     0,     0,     0,    37,
       0,     0,     0,     4,     5,     6,     7,     8,    16,    17,
      18,    37,     0,     4,     5,     6,     7,     8,    16,    17,
      18,    37,     0,     0,     0,     0,     0,     0,     0,    19,
      16,    17,    18,     0,     0,    38,    21,     0,    39,    19,
      16,    17,    18,    23,     0,     0,    21,     0,    39,    46,
       0,    19,     0,    23,     0,     0,     0,     0,    21,   126,
      39,    19,     0,     0,     0,    23,     0,     0,    21,   185,
      39,     0,     0,     0,     0,    23,     4,     5,     6,     7,
       8,     0,     0,     0,    37,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,     0,     0,     0,     0,
       0,     0,     0,    16,    17,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    70,
      71,     0,     0,     0,    19,     0,     0,     0,     0,     0,
       0,    21,     0,    39,    72,    73,    74,     0,    23,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    70,    71,     0,
       0,     0,     0,     0,     0,     0,     0,   172,     0,     0,
       0,     0,    72,    73,    74,     0,     0,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    70,    71,     0,     0,     0,
       0,     0,     0,     0,     0,   184,     0,     0,     0,     0,
      72,    73,    74,     0,     0,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    70,    71,     0,   108,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    72,    73,
      74,     0,     0,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    70,    71,     0,   156,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    72,    73,    74,     0,
       0,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    70,
      71,     0,   157,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    72,    73,    74,     0,     0,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    70,    71,     0,
     192,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    72,    73,    74,     0,     0,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    70,    71,     0,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      72,    73,    74,     0,   112,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,     0,    93,    70,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      72,    73,    74,     0,     0,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,     0,    93,    70,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      72,    73,    74,     0,     0,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,     0,   107,    70,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      72,    73,    74,     0,     0,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,     0,   182,    70,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      72,    73,    74,   115,     0,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    70,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    72,    73,
      74,     0,   112,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    70,    71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    72,    73,    74,     0,
     183,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    70,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    72,    73,    74,     0,     0,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    72,    73,    74,
       0,     0,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92
};

static const yytype_int16 yycheck[] =
{
      25,    30,    66,     7,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    62,     7,    64,    65,
      15,    22,    47,    18,    19,    58,    21,    22,    23,     0,
      31,    64,    65,    28,    29,    11,    62,     7,    64,    65,
      16,    17,    58,    13,    39,    57,     7,    63,    64,    65,
      62,    62,    61,    62,    58,    66,    60,    33,    58,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    59,
      99,    66,    67,    98,    69,    70,    71,    72,    73,    58,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    74,   100,
      48,    49,    50,    51,    52,    53,    54,    55,   103,   173,
      50,    51,    52,    53,    54,    55,   111,   112,   113,     4,
     115,    58,     7,    60,    58,   101,    59,    64,    65,    62,
      57,   156,   157,    52,    53,    54,    55,   162,    59,    59,
       7,    62,    62,     3,     4,     5,     6,     7,    58,     7,
      60,    11,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,   187,   188,   189,    64,    65,   192,    63,   164,
      30,    31,    32,   198,   199,   176,   177,    59,   173,     7,
      62,    60,    60,    17,    60,   180,    -1,    -1,   183,   190,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      60,    -1,    -1,    -1,    -1,    65,    66,     3,     4,     5,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
       3,     4,     5,     6,     7,    -1,     9,    10,    11,    12,
      13,    14,    15,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    57,    58,    -1,    60,    61,    -1,    -1,    51,    65,
      -1,    -1,    -1,    -1,    57,    58,    -1,    60,    61,    -1,
      -1,    -1,    65,     3,     4,     5,     6,     7,    -1,     9,
      10,    11,    12,    13,    14,    15,     3,     4,     5,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    15,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    57,    58,    -1,
      60,    61,    -1,    -1,    51,    65,    -1,    -1,    -1,    -1,
      57,    58,    -1,    60,    61,    -1,    -1,    -1,    65,     3,
       4,     5,     6,     7,    -1,     9,    10,    11,    12,    13,
      14,    15,     3,     4,     5,     6,     7,    -1,     9,    10,
      11,    12,    13,    14,    15,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    57,    58,    -1,    60,    61,    -1,    -1,
      51,    65,    -1,    -1,    -1,    -1,    57,    58,    -1,    60,
      61,    -1,    -1,    -1,    65,     3,     4,     5,     6,     7,
      -1,     9,    10,    11,    12,    13,    14,    15,     3,     4,
       5,     6,     7,    -1,     9,    10,    11,    12,    13,    14,
      15,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    57,
      58,    -1,    60,    61,    -1,    -1,    51,    65,    -1,    -1,
      -1,    -1,    57,    58,    -1,    60,    -1,    -1,    -1,    -1,
      65,     3,     4,     5,     6,     7,    -1,    -1,    -1,    11,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    11,
      -1,    -1,    -1,     3,     4,     5,     6,     7,    30,    31,
      32,    11,    -1,     3,     4,     5,     6,     7,    30,    31,
      32,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      30,    31,    32,    -1,    -1,    57,    58,    -1,    60,    51,
      30,    31,    32,    65,    -1,    -1,    58,    -1,    60,    61,
      -1,    51,    -1,    65,    -1,    -1,    -1,    -1,    58,    59,
      60,    51,    -1,    -1,    -1,    65,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    -1,    65,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    11,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    58,    -1,    60,    33,    34,    35,    -1,    65,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    33,    34,    35,    -1,    -1,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      33,    34,    35,    -1,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    18,    19,    -1,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      35,    -1,    -1,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    18,    19,    -1,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    35,    -1,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    18,
      19,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    35,    -1,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    18,    19,    -1,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    35,    -1,    -1,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    18,    19,    -1,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    35,    -1,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    35,    -1,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    35,    -1,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    35,    -1,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    33,    34,    35,
      -1,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    68,    69,     0,     3,     4,     5,     6,     7,     9,
      10,    11,    12,    13,    14,    15,    30,    31,    32,    51,
      57,    58,    60,    65,    70,    71,    75,    76,    58,    58,
      58,    60,    75,    58,     7,    73,    57,    11,    57,    60,
      76,    75,    75,    76,    76,    76,    61,    71,    74,    76,
      66,    72,    76,    70,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    58,    63,    64,    65,
      18,    19,    33,    34,    35,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    57,    76,    76,     7,    73,    71,    58,
      60,    13,    75,    63,    57,    62,    76,    57,    59,    61,
      61,    62,    37,    62,    66,    36,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    59,    72,    76,    76,
       4,     7,    76,    76,    76,    76,    76,    75,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    59,    59,    59,    61,
      59,    73,    71,    75,    62,    76,     7,    76,    76,    76,
      76,    59,    66,    58,    70,    70,    60,    60,    59,    61,
      62,    76,    57,    37,    66,    59,    72,    17,    71,    71,
      60,    76,    59,    76,    59,    70,    61,    61,    71,    59,
      70,    61,    70
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 114 "mpsl.y"
    { ; }
    break;

  case 3:
#line 118 "mpsl.y"
    {
					mpsl_bytecode = (yyvsp[(2) - (2)].ins);
				}
    break;

  case 5:
#line 125 "mpsl.y"
    {
					/* null instruction */
					(yyval.ins) = INS0(L"MULTI");
				}
    break;

  case 6:
#line 129 "mpsl.y"
    {
					/* expression, as is */
					(yyval.ins) = (yyvsp[(1) - (2)].ins);
				}
    break;

  case 7:
#line 135 "mpsl.y"
    {
					/* while loop */
					(yyval.ins) = INS2(L"WHILE", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins));
				}
    break;

  case 8:
#line 140 "mpsl.y"
    {
					/* if - then construction */
					(yyval.ins) = INS2(L"IF", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins));
				}
    break;

  case 9:
#line 145 "mpsl.y"
    {
					/* if - then - else construction */
					(yyval.ins) = INS3(L"IF", (yyvsp[(3) - (7)].ins), (yyvsp[(5) - (7)].ins), (yyvsp[(7) - (7)].ins));
				}
    break;

  case 10:
#line 151 "mpsl.y"
    {
					/* subroutine definition,
					   without arguments */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (5)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(4) - (5)].ins), NULL, 1)));
				}
    break;

  case 11:
#line 160 "mpsl.y"
    {
					/* subroutine definition,
					   without arguments (second
					   syntax, including parens) */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (7)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(6) - (7)].ins), NULL, 1)));
				}
    break;

  case 12:
#line 170 "mpsl.y"
    {
					/* subroutine definition,
					   with arguments */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (8)].ins),
						INS1(L"LITERAL",
							mpsl_x((yyvsp[(7) - (8)].ins), (yyvsp[(4) - (8)].ins), 1)));
				}
    break;

  case 13:
#line 179 "mpsl.y"
    {
					/* foreach construction */
					/* a block frame is created, the iterator
					   created as local, and the foreach executed */
					(yyval.ins) = INS1(L"BLKFRAME",
						INS2(L"MULTI",
							INS1(L"LOCAL", (yyvsp[(3) - (7)].ins)),
							INS3(L"FOREACH", (yyvsp[(3) - (7)].ins), (yyvsp[(5) - (7)].ins), (yyvsp[(7) - (7)].ins))
						)
					);
				}
    break;

  case 14:
#line 191 "mpsl.y"
    {
					compiler_warning("useless use of local in foreach loop");

					(yyval.ins) = INS1(L"BLKFRAME",
						INS2(L"MULTI",
							INS1(L"LOCAL", (yyvsp[(4) - (8)].ins)),
							INS3(L"FOREACH", (yyvsp[(4) - (8)].ins), (yyvsp[(6) - (8)].ins), (yyvsp[(8) - (8)].ins))
						)
					);
				}
    break;

  case 15:
#line 202 "mpsl.y"
    {
					/* block of instructions,
					   with local symbol table */
					(yyval.ins) = INS1(L"BLKFRAME", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 16:
#line 208 "mpsl.y"
    {
					/* local symbol creation */
					(yyval.ins) = INS1(L"LOCAL", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 17:
#line 213 "mpsl.y"
    {
					/* contraction; local symbol
					   creation and assignation */
					(yyval.ins) = INS2(L"MULTI",
						INS1(L"LOCAL",
							INS1(L"LITERAL", (yyvsp[(2) - (5)].v))),
						INS2(L"ASSIGN",
							INS1(L"LITERAL", (yyvsp[(2) - (5)].v)),(yyvsp[(4) - (5)].ins))
						);
				}
    break;

  case 18:
#line 223 "mpsl.y"
    {
					/* break (exit from loop) */
					(yyval.ins) = INS0(L"BREAK");
				}
    break;

  case 19:
#line 227 "mpsl.y"
    {
					/* return from subroutine */
					(yyval.ins) = INS1(L"RETURN", (yyvsp[(2) - (3)].ins));
				}
    break;

  case 20:
#line 231 "mpsl.y"
    {
					/* return from subroutine (void) */
					(yyval.ins) = INS0(L"RETURN");
				}
    break;

  case 21:
#line 238 "mpsl.y"
    { (yyval.ins) = (yyvsp[(1) - (1)].ins); }
    break;

  case 22:
#line 239 "mpsl.y"
    {
					/* sequence of instructions */
					(yyval.ins) = INS2(L"MULTI", (yyvsp[(1) - (2)].ins), (yyvsp[(2) - (2)].ins));
				}
    break;

  case 23:
#line 246 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST", (yyvsp[(1) - (1)].ins));
				}
    break;

  case 24:
#line 249 "mpsl.y"
    {
					/* build list from list of
					   instructions */
					(yyval.ins) = INS2(L"LIST", (yyvsp[(3) - (3)].ins), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 25:
#line 257 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST",
						INS1(L"LITERAL", (yyvsp[(1) - (1)].v)));
				}
    break;

  case 26:
#line 261 "mpsl.y"
    {
					/* comma-separated list of symbols */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 27:
#line 269 "mpsl.y"
    {
					(yyval.ins) = INS2(L"HASH", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 28:
#line 273 "mpsl.y"
    {
					/* build hash from list of
					   instructions */
					(yyval.ins) = INS3(L"HASH", (yyvsp[(3) - (5)].ins), (yyvsp[(5) - (5)].ins), (yyvsp[(1) - (5)].ins));
				}
    break;

  case 29:
#line 281 "mpsl.y"
    {
					(yyval.ins) = INS1(L"LIST",
						INS1(L"LITERAL", (yyvsp[(1) - (1)].v)));
				}
    break;

  case 30:
#line 285 "mpsl.y"
    {
					/* a.5 compound symbol */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 31:
#line 290 "mpsl.y"
    {
					/* a.b compound symbol */
					(yyval.ins) = INS2(L"LIST",
						INS1(L"LITERAL", (yyvsp[(3) - (3)].v)), (yyvsp[(1) - (3)].ins));
				}
    break;

  case 32:
#line 295 "mpsl.y"
    {
					/* a["b"] or a[5] compound symbol */
					(yyval.ins) = INS2(L"LIST", (yyvsp[(3) - (4)].ins), (yyvsp[(1) - (4)].ins));
				}
    break;

  case 33:
#line 302 "mpsl.y"
    {
					/* literal integer */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 34:
#line 306 "mpsl.y"
    {
					/* literal string */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 35:
#line 310 "mpsl.y"
    {
					/* literal real number */
					(yyval.ins) = INS1(L"LITERAL", (yyvsp[(1) - (1)].v));
				}
    break;

  case 36:
#line 314 "mpsl.y"
    {
					/* compound symbol */
					(yyval.ins) = INS1(L"SYMVAL", (yyvsp[(1) - (1)].ins));
				}
    break;

  case 37:
#line 318 "mpsl.y"
    {
					/* NULL value */
					(yyval.ins) = INS1(L"LITERAL", NULL);
				}
    break;

  case 38:
#line 323 "mpsl.y"
    {
					/* unary minus */
					(yyval.ins) = INS1(L"UMINUS", (yyvsp[(2) - (2)].ins));
				}
    break;

  case 39:
#line 329 "mpsl.y"
    { (yyval.ins) = INS2(L"ADD", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 40:
#line 330 "mpsl.y"
    { (yyval.ins) = INS2(L"SUB", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 41:
#line 331 "mpsl.y"
    { (yyval.ins) = INS2(L"MUL", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 42:
#line 332 "mpsl.y"
    { (yyval.ins) = INS2(L"DIV", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 43:
#line 333 "mpsl.y"
    { (yyval.ins) = INS2(L"MOD", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 44:
#line 334 "mpsl.y"
    { (yyval.ins) = INS2(L"POW", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 45:
#line 337 "mpsl.y"
    { (yyval.ins) = INS2(L"BITAND", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 46:
#line 338 "mpsl.y"
    { (yyval.ins) = INS2(L"BITOR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 47:
#line 339 "mpsl.y"
    { (yyval.ins) = INS2(L"BITXOR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 48:
#line 340 "mpsl.y"
    { (yyval.ins) = INS2(L"SHL", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 49:
#line 341 "mpsl.y"
    { (yyval.ins) = INS2(L"SHR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)); }
    break;

  case 50:
#line 344 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (2)].ins),
					INS2(L"ADD",
						INS1(L"SYMVAL", (yyvsp[(2) - (2)].ins)),
						INS1(L"LITERAL", MPDM_I(1))
						)
					);
				}
    break;

  case 51:
#line 351 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(2) - (2)].ins),
					INS2(L"SUB",
						INS1(L"SYMVAL", (yyvsp[(2) - (2)].ins)),
						INS1(L"LITERAL", MPDM_I(1))
						)
					);
				}
    break;

  case 52:
#line 360 "mpsl.y"
    { (yyval.ins) = INS2(L"IMULTI",
					INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
					INS2(L"ASSIGN", (yyvsp[(1) - (2)].ins),
						INS2(L"ADD",
							INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
							INS1(L"LITERAL", MPDM_I(1))
							)
						)
					);
				}
    break;

  case 53:
#line 370 "mpsl.y"
    { (yyval.ins) = INS2(L"IMULTI",
					INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
					INS2(L"ASSIGN", (yyvsp[(1) - (2)].ins),
						INS2(L"SUB",
							INS1(L"SYMVAL", (yyvsp[(1) - (2)].ins)),
							INS1(L"LITERAL", MPDM_I(1))
							)
						)
					);
				}
    break;

  case 54:
#line 382 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"ADD",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 55:
#line 388 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"SUB",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 56:
#line 394 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"MUL",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 57:
#line 400 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"DIV",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 58:
#line 406 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"MOD",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 59:
#line 412 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"BITAND",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 60:
#line 418 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"BITOR",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 61:
#line 424 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"BITXOR",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 62:
#line 430 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"SHL",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 63:
#line 436 "mpsl.y"
    { (yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins),
					INS2(L"SHR",
						INS1(L"SYMVAL", (yyvsp[(1) - (3)].ins)),
						(yyvsp[(3) - (3)].ins))
					);
				}
    break;

  case 64:
#line 443 "mpsl.y"
    {
					/* boolean not */
					(yyval.ins) = INS1(L"NOT", (yyvsp[(2) - (2)].ins));
				}
    break;

  case 65:
#line 447 "mpsl.y"
    {
					/* bool less than */
					(yyval.ins) = INS2(L"NUMLT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 66:
#line 451 "mpsl.y"
    {
					/* bool greater than */
					(yyval.ins) = INS2(L"NUMGT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 67:
#line 455 "mpsl.y"
    {
					/* bool less or equal than */
					(yyval.ins) = INS2(L"NUMLE", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 68:
#line 459 "mpsl.y"
    {
					/* bool greater or equal than */
					(yyval.ins) = INS2(L"NUMGE", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 69:
#line 463 "mpsl.y"
    {
					/* bool numeric equal */
					(yyval.ins) = INS2(L"NUMEQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 70:
#line 467 "mpsl.y"
    {
					/* bool numeric non-equal */
					(yyval.ins) = INS1(L"NOT",
						INS2(L"NUMEQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)));
				}
    break;

  case 71:
#line 473 "mpsl.y"
    {
					/* string concatenation */
					(yyval.ins) = INS2(L"STRCAT", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 72:
#line 477 "mpsl.y"
    {
					/* bool string equal */
					(yyval.ins) = INS2(L"STREQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 73:
#line 481 "mpsl.y"
    {
					/* bool string non-equal */
					(yyval.ins) = INS1(L"NOT",
						INS2(L"STREQ", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins)));
				}
    break;

  case 74:
#line 487 "mpsl.y"
    {
					/* boolean and */
					(yyval.ins) = INS2(L"AND", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 75:
#line 491 "mpsl.y"
    {
					/* boolean or */
					(yyval.ins) = INS2(L"OR", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;

  case 76:
#line 496 "mpsl.y"
    {
					/* anonymous subroutine (without args) */
					(yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[(3) - (4)].ins), NULL, 0));
				}
    break;

  case 77:
#line 502 "mpsl.y"
    {
					/* anonymous subroutine (with args) */
					(yyval.ins) = INS1(L"LITERAL", mpsl_x((yyvsp[(6) - (7)].ins), (yyvsp[(3) - (7)].ins), 0));
				}
    break;

  case 78:
#line 507 "mpsl.y"
    {
					/* parenthesized expression */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 79:
#line 512 "mpsl.y"
    {
					/* empty list */
					(yyval.ins) = INS1(L"LITERAL", MPDM_A(0));
				}
    break;

  case 80:
#line 516 "mpsl.y"
    {
					/* non-empty list */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 81:
#line 521 "mpsl.y"
    {
					/* build range from expressions */
					(yyval.ins) = INS2(L"RANGE", (yyvsp[(2) - (5)].ins), (yyvsp[(4) - (5)].ins));
				}
    break;

  case 82:
#line 526 "mpsl.y"
    {
					/* empty hash */
					(yyval.ins) = INS1(L"LITERAL", MPDM_H(0));
				}
    break;

  case 83:
#line 530 "mpsl.y"
    {
					/* non-empty hash */
					(yyval.ins) = (yyvsp[(2) - (3)].ins);
				}
    break;

  case 84:
#line 535 "mpsl.y"
    {
					/* function call (without args) */
					(yyval.ins) = INS1(L"EXECSYM", (yyvsp[(1) - (3)].ins));
				}
    break;

  case 85:
#line 539 "mpsl.y"
    {
					/* function call (with args) */
					(yyval.ins) = INS2(L"EXECSYM", (yyvsp[(1) - (4)].ins), (yyvsp[(3) - (4)].ins));
				}
    break;

  case 86:
#line 543 "mpsl.y"
    {
					/* function call with only an inverse argument */
					(yyval.ins) = INS2(L"EXECSYM", (yyvsp[(3) - (5)].ins), INS1(L"ILIST", (yyvsp[(1) - (5)].ins)));
				}
    break;

  case 87:
#line 547 "mpsl.y"
    {
					/* function call with inverse argument and other ones */
					(yyval.ins) = INS2(L"EXECSYM", (yyvsp[(3) - (6)].ins), INS2(L"ILIST", (yyvsp[(1) - (6)].ins), (yyvsp[(5) - (6)].ins)));
				}
    break;

  case 88:
#line 551 "mpsl.y"
    {
					/* simple assignation */
					(yyval.ins) = INS2(L"ASSIGN", (yyvsp[(1) - (3)].ins), (yyvsp[(3) - (3)].ins));
				}
    break;


/* Line 1267 of yacc.c.  */
#line 2593 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 558 "mpsl.y"


void yyerror(char * s)
{
	char tmp[1024];

	snprintf(tmp, sizeof(tmp), "%s in %s, line %d",
		s, mpsl_filename, mpsl_line + 1);

	mpsl_error(MPDM_MBS(tmp));
}


static FILE * inc_fopen(const char * filename, mpdm_t inc)
/* loads filename, searching in INC if not directly accesible */
{
	FILE * f = NULL;
	char tmp[1024];
	int n;

	/* loop through INC, prepending each path
	   to the filename */
	for (n = 0; n < mpdm_size(inc); n++) {
		mpdm_t v = mpdm_aget(inc, n);

		v = MPDM_2MBS(v->data);
		snprintf(tmp, sizeof(tmp), "%s/%s",
			(char *)v->data, filename);

		if ((f = fopen(tmp, "r")) != NULL)
			break;
	}

	return f;
}


static mpdm_t do_parse(const char * filename, wchar_t * code, FILE * file)
/* calls yyparse() after doing some initialisations, and returns
   the compiled code as an executable value */
{
	mpdm_t v;
	mpdm_t x = NULL;

	/* first line */
	mpsl_line = 0;

	/* reset last bytecode */
	mpsl_bytecode = NULL;

	/* set globals */
	mpsl_next_char = code;
	mpsl_file = file;

	if (mpsl_filename != NULL)
		free(mpsl_filename);

	mpsl_filename = strdup(filename);

	/* cache some values */
	v = mpdm_hget_s(mpdm_root(), L"MPSL");
	mpsl_opcodes = mpdm_hget_s(v, L"OPCODE");
	mpsl_lc = mpdm_hget_s(v, L"LC");

	/* compile! */
	if (yyparse() == 0 && mpsl_bytecode != NULL)
		x = mpsl_x(mpsl_bytecode, NULL, 1);

	/* clean back cached values */
	mpsl_opcodes = NULL;
	mpsl_lc = NULL;

	return x;
}


/**
 * mpsl_compile - Compiles a string of MPSL code.
 * @code: A value containing a string of MPSL code
 *
 * Compiles a string of MPSL code and returns an mpdm value executable
 * by mpdm_exec(). If there is a syntax (or other type) error, NULL
 * is returned instead.
 */
mpdm_t mpsl_compile(mpdm_t code)
{
	mpdm_t x = NULL;

	mpdm_ref(code);
	x = do_parse("<INLINE>", (wchar_t *) code->data, NULL);
	mpdm_unref(code);

	return x;
}


/**
 * mpsl_compile_file - Compiles a file of MPSL code.
 * @file: File stream or file name.
 *
 * Compiles a source file of MPSL code and returns an mpdm value
 * executable by mpdm_exec(). If @file is an MPSL file descriptor,
 * it's read as is and compiled; otherwise, it's assumed to be a
 * file name, that will be searched for in any of the paths defined
 * in the INC MPSL global array (take note that the current
 * directory is NOT searched by default). If the file cannot be found
 * or there is any other error, NULL is returned instead.
 */
mpdm_t mpsl_compile_file(mpdm_t file)
{
	mpdm_t x = NULL;
	FILE * f = NULL;
	const char * filename = NULL;

	if ((f = mpdm_get_filehandle(file)) != NULL) {
		filename = "<FILE>";
	}
	else {
		mpdm_t inc = mpsl_get_symbol(MPDM_LS(L"INC"));

		/* it's a filename; open it */
		file = MPDM_2MBS(file->data);

		filename = file->data;

		if ((f = inc_fopen(filename, inc)) == NULL) {
			char tmp[128];

			snprintf(tmp, sizeof(tmp) - 1,
				"File '%s' not found in INC",
				filename);
			mpsl_error(MPDM_MBS(tmp));

			return (NULL);
		}

		file = MPDM_F(f);
	}

	x = do_parse(filename, NULL, f);

	mpdm_close(file);

	return x;
}


/**
 * mpsl_eval - Evaluates MSPL code.
 * @code: A value containing a string of MPSL code, or executable code
 * @args: optional arguments for @code
 *
 * Evaluates a piece of code. The @code can be a string containing MPSL source
 * code (that will be compiled) or a direct executable value. If the compilation
 * or the execution gives an error, the ERROR variable will be set to a printable
 * value and NULL returned. Otherwise, the exit value from the code is returned
 * and ERROR set to NULL. The abort flag is reset on exit.
 */
mpdm_t mpsl_eval(mpdm_t code, mpdm_t args)
{
	mpdm_t v = NULL;

	/* reset error */
	mpsl_error(NULL);
	mpsl_abort = 0;

	/* if code is not executable, try to compile */
	if (!MPDM_IS_EXEC(code))
		code = mpsl_compile(code);

	/* execute, if possible */
	if (MPDM_IS_EXEC(code))
		v = mpdm_exec(code, args);

	/* reset the abort flag */
	mpsl_abort = 0;

	return v;
}

